// assuming that csrfBasic.js has already been loaded
// change zeroClient to whatever object the Project Zero client side code lives in

zeroClient.CSRFXhrWrapper = new (function() {
	var that = this;

	/*
	Wrap a newly created xhr object for transparent CSRF protection. Should be called before
	calling open
	*/
	this.wrapXhr = function(/*XHR*/ xhr) {
		if (xhr != null) {
			if (xhr._zeroRealOpen === undefined) {
				// Do not re-define if we already did wrap that object as this would create an infinite loop otherwise
				xhr._zeroRealOpen = xhr.open;
				xhr.open = _xhr_openwrapper;
			}
		}
		return xhr;
	}
	
	this._dojo_xhrObj = null;

	/*
	Wrap all XHR objects created in the future by Dojo 
	*/	
	this.wrapDojo = function() {
		// wrap the dojo._xhrObj
		if (dojo != null) {
			that._dojo_xhrObj = dojo._xhrObj;
			dojo._xhrObj = function() {
				var xhr;
				xhr = that._dojo_xhrObj.apply(that, arguments);
				xhr = that.wrapXhr(xhr);
				return xhr;
			}
		}	
	}

	// function to wrap the xhr.open method
	function _xhr_openwrapper() {
		var url = arguments[1];
		if (arguments.length == 2)
			this._zeroRealOpen(arguments[0], arguments[1]);			
		else if (arguments.length == 3)
			this._zeroRealOpen(arguments[0], arguments[1], arguments[2]);
		else if (arguments.length == 4)
			this._zeroRealOpen(arguments[0], arguments[1], arguments[2], arguments[3]);
		else if (arguments.length == 5)
			this._zeroRealOpen(arguments[0], arguments[1], arguments[2], arguments[3], arguments[4]);
		else 
			throw new Error("Zero CSRF: incorrect number of arguments to xhr.open");
 	    // below ``apply'' does not work as IE DOM/COM/ActiveX objects do not support apply/call: 
	    // See e.g., http://my.opera.com/_Grey_/blog/2007/04/15/wrapping-ies-dom-functions
	    // http://snippets.dzone.com/posts/show/717 would give a workaround but not worth 
		// for this case ....
		// this._zeroRealOpen.apply(this, arguments);
		zeroClient.CSRFBasic.addCSRFTokenToHeader(url, this);
	}
})();

// call to wrap dojo
zeroClient.CSRFXhrWrapper.wrapDojo();